]> pd.if.org Git - zpackage/blobdiff - t/tap.sh
add -o option to runscript
[zpackage] / t / tap.sh
index 23c52997190d8f127cab8a8384f828d92bcf50f2..580fcbd2d02d6be9e0627a880af59dee46bd6ad8 100755 (executable)
--- a/t/tap.sh
+++ b/t/tap.sh
@@ -7,7 +7,7 @@ tryrun() {
        note="$@"
        program=$1
        shift
-       $program "$@"
+       $program "$@" >> test.out 2>&1
        if [ $? -ne 0 ]; then
                printf 'not ';
        fi
@@ -15,21 +15,55 @@ tryrun() {
        printf 'ok %d - %s %s\n' $tn $program "$*"
 }
 
+require() {
+       note="$*"
+       program=$1
+       shift
+       $program "$@" >> test.out 2>&1
+       rv=$?
+       tn=$((tn + 1))
+       if [ $rv -ne 0 ]; then
+               printf 'not ok %d - %s %s\n' $tn $program "$*"
+               bailout "exit status $rv";
+       fi
+       printf 'ok %d - %s %s\n' $tn $program "$*"
+
+}
+
+bailout() {
+       diag "$@"
+       printf "bail out!\n";
+       exit 255;
+}
+
 shownote() {
        if [ "$note" != "" ]; then
                printf '# %s\n' "$note"
        fi
 }
 
+diag() {
+       printf '# %s\n' "$@"
+}
+
+diagfile() {
+       sed -e 's/^/# /' $1
+}
+
+diagstdin() {
+       sed -e 's/^/# /'
+}
+
 okexit() {
        exitwith 0 "$*"
 }
 
 failsok() {
+       rv=$?
        note=
-       if [ $? -eq 0 ]; then
+       if [ $rv -eq 0 ]; then
                printf 'not ';
-               note=$(printf '# got "%d" expected "%d"' "$1" "0")
+               note=$(printf 'got "%d" expected "%d"' "$rv" "0")
        fi
        tn=$((tn + 1))
        printf 'ok %d - %s\n' $tn "$*"
@@ -37,10 +71,11 @@ failsok() {
 }
 
 exitwith() {
+       rv=$?
        note=
-       if [ $? -ne $1 ]; then
+       if [ $rv -ne $1 ]; then
                printf 'not ';
-               note=$(printf '# got "%d" expected "%d"' "$1" "$2")
+               note=$(printf '# got "%d" expected "%d"' "$rv" "$1")
        fi
        shift
        tn=$((tn + 1))